# Usage Data

This module is intended for internal site analytics, treating page
views and downloads as events which are recorded to a usage_data table.

## Installation

1. Install module as usual.

2. Allow to execute custom controller in your .htaccess. 
Below the Statistics module's rule add similar condition:


    RewriteCond %{REQUEST_URI} !/modules/contrib/usage_data/usage_data\.php$


## Data structure

You can then pull your data out with Views Database Connector
(drupal.org/project/views_database_connector) or by writing your own
queries. You can add your own columns to the usage_data table by writing
your own install hook (hook_install()).

The default structure is as follows:

| id | event_type | entity_id | entity_type_id | path     | timestamp  | uid | user_name | user_role       | count |
|----|------------|-----------|----------------|----------|------------|-----|-----------|-----------------|-------|
| 1  | view       | 2         | node           | /about   | 1635444980 | 1   | admin     | administrator   | 1     |
| 2  | download   | 30        | media          | /reports | 1635444981 | 2   | editor    | content_manager | 1     |

Please be responsible when collecting data from your users.

## Redis queue

1. Make sure that you enabled and setup <a href="https://www.drupal.org/project/redis" target="_blank">Redis</a> module.

2. Add to your settings.php:


    # Use this to only use Redis for a specific queue (usage_data_records in this case).
    $settings['queue_service_usage_data_records'] = 'queue.redis'; 

## Click tracking

Your tracked link should have ```data-usage=""``` attribute with usage data as a JSON string. For example:


    <a href="https://example.com/search?arg1=1&arg2=2" data-usage="{'entity_id':'27','entity_type_id':'media'}">Tracked link</a>

#### Parameters:

    Required:
      - entity_type_id - entity type id.
      - entity_id - entity id.
    
    Optional:  
      - path - if empty it will be set from the link href or current page url.
    
##
 
**Authors:** Nia Kathoni (nikathone) & Daniel Cothran (andileco)
