/**
 * @file
 * Usage Data functionality.
 */

(function ($, Drupal, drupalSettings) {

  'use strict';

  $(document).ready(function () {
    // Track view event.
    if (drupalSettings.usage_data.data) {
      $.ajax({
        type: 'POST',
        cache: false,
        url: drupalSettings.usage_data.url,
        data: drupalSettings.usage_data.data
      });
    }

    // Track click event.
    $('[data-usage]').on('click', function (e, options) {
      var data = JSON.parse($(this).attr('data-usage'));
      if (!data) {
        return;
      }
      // Add path info if not set.
      if (!data['path']) {
        var href = $(this).attr('href') ? $(this).attr('href') : location.href;
        data['path'] = href.replace(location.origin, '');
      }
      $.ajax({
        type: 'POST',
        cache: false,
        url: drupalSettings.usage_data.url,
        data: {
          'type': 'click',
          'info': data
        }
      });
    });
  });

})(jQuery, Drupal, drupalSettings);
