<?php

namespace Drupal\usage_data\Plugin;

use Drupal\Component\Plugin\PluginManagerInterface;

/**
 * Provides an interface for the UsageTypeManager.
 */
interface UsageTypeManagerInterface extends PluginManagerInterface {

  /**
   * Gets the definition of all enabled plugins for this type.
   *
   * @return mixed[]
   *   An array of plugin definitions (empty array if no definitions were
   *   found). Keys are plugin IDs.
   *
   * @see \Drupal\Core\Plugin\FilteredPluginManagerInterface::getFilteredDefinitions()
   */
  public function getActiveDefinitions();

  /**
   * Gets available event types.
   *
   * @return array
   *   An array of available event types for active plugins.
   */
  public function getAvailableEventTypes();

}
